openshot::ColorShift Class Reference

This class shifts the pixels of an image up, down, left, or right, and can be animated with openshot::Keyframe curves over time. More...

`#include <ColorShift.h>`

Inheritance diagram for openshot::ColorShift:

## Public Member Functions

| ColorShift ()
| Blank constructor, useful when using Json to load the effect properties. More...
| ColorShift (Keyframe red_x, Keyframe red_y, Keyframe green_x, Keyframe green_y, Keyframe blue_x, Keyframe blue_y, Keyframe alpha_x, Keyframe alpha_y)
std::shared_ptr< Frame > | GetFrame (std::shared_ptr< Frame > frame, int64_t frame_number)
| This method is required for all derived classes of EffectBase, and returns a modified openshot::Frame object. More...
string | Json ()
| Get and Set JSON methods. More...
Json::Value | JsonValue ()
| Generate Json::JsonValue for this object. More...
string | PropertiesJSON (int64_t requested_frame)
void | SetJson (string value)
| Load JSON string into this object. More...
void | SetJsonValue (Json::Value root)
| Load Json::JsonValue into this object. More...
Public Member Functions inherited from openshot::EffectBase
int | constrain (int color_value)
| Constrain a color value from 0 to 255. More...
void | DisplayInfo ()
| Display effect information in the standard output stream (stdout) More...
void | InitEffectInfo ()
Json::Value | JsonInfo ()
| Generate JSON object of meta data / info. More...
int | Order ()
| Get the order that this effect should be executed. More...
void | Order (int new_order)
| Set the order that this effect should be executed. More...
Public Member Functions inherited from openshot::ClipBase
| ClipBase ()
| Constructor for the base clip. More...
void | Id (string value)
| Set basic properties. More...
bool | operator< (ClipBase &a)
bool | operator<= (ClipBase &a)
bool | operator> (ClipBase &a)
bool | operator>= (ClipBase &a)
void | SetMaxSize (int width, int height)
| Set Max Image Size (used for performance optimization) More...

## Public Attributes

Keyframe | alpha_x
| Shift the Alpha X coordinates (left or right) More...
Keyframe | alpha_y
| Shift the Alpha Y coordinates (up or down) More...
Keyframe | blue_x
| Shift the Blue X coordinates (left or right) More...
Keyframe | blue_y
| Shift the Blue Y coordinates (up or down) More...
Keyframe | green_x
| Shift the Green X coordinates (left or right) More...
Keyframe | green_y
| Shift the Green Y coordinates (up or down) More...
Keyframe | red_x
| Shift the Red X coordinates (left or right) More...
Keyframe | red_y
| Shift the Red Y coordinates (up or down) More...
Public Attributes inherited from openshot::EffectBase
EffectInfoStruct | info
| Information about the current effect. More...

## Additional Inherited Members

Protected Member Functions inherited from openshot::ClipBase
Json::Value | add_property_choice_json (string name, int value, int selected_value)
| Generate JSON choice for a property (dropdown properties) More...
Json::Value | add_property_json (string name, float value, string type, string memo, Keyframe *keyframe, float min_value, float max_value, bool readonly, int64_t requested_frame)
| Generate JSON for a property. More...
Protected Attributes inherited from openshot::ClipBase
float | end
| The position in seconds to end playing (used to trim the ending of a clip) More...
string | id
| ID Property for all derived Clip and Effect classes. More...
int | layer
| The layer this clip is on. Lower clips are covered up by higher clips. More...
int | max_height
| The maximium image height needed by this clip (used for optimizations) More...
int | max_width
| The maximum image width needed by this clip (used for optimizations) More...
float | position
| The position on the timeline where this clip should start playing. More...
string | previous_properties
| This string contains the previous JSON properties. More...
float | start
| The position in seconds to start playing (used to trim the beginning of a clip) More...

## Detailed Description

This class shifts the pixels of an image up, down, left, or right, and can be animated with openshot::Keyframe curves over time.

Shifting pixels can be used in many interesting ways, especially when animating the movement of the pixels. The pixels wrap around the image (the pixels drop off one side and appear on the other side of the image).

Definition at line 52 of file ColorShift.h.

## Constructor & Destructor Documentation

## ColorShift() [1/2]

ColorShift::ColorShift | ( |  | ) |

Blank constructor, useful when using Json to load the effect properties.

Definition at line 33 of file ColorShift.cpp.

## ColorShift() [2/2]

ColorShift::ColorShift | ( | Keyframe | red_x,
|  | Keyframe | red_y,
|  | Keyframe | green_x,
|  | Keyframe | green_y,
|  | Keyframe | blue_x,
|  | Keyframe | blue_y,
|  | Keyframe | alpha_x,
|  | Keyframe | alpha_y
| ) |  |

Default constructor, which takes 8 curves. The curves will shift the RGBA pixels up, down, left, or right

Parameters

  red_x | The curve to adjust the Red x shift (between -1 and 1, percentage)
  red_y | The curve to adjust the Red y shift (between -1 and 1, percentage)
  green_x | The curve to adjust the Green x shift (between -1 and 1, percentage)
  green_y | The curve to adjust the Green y shift (between -1 and 1, percentage)
  blue_x | The curve to adjust the Blue x shift (between -1 and 1, percentage)
  blue_y | The curve to adjust the Blue y shift (between -1 and 1, percentage)
  alpha_x | The curve to adjust the Alpha x shift (between -1 and 1, percentage)
  alpha_y | The curve to adjust the Alpha y shift (between -1 and 1, percentage)

Definition at line 39 of file ColorShift.cpp.

## Member Function Documentation

## GetFrame()

std::shared_ptr< Frame > ColorShift::GetFrame | ( | std::shared_ptr< Frame > | frame,
|  | int64_t | frame_number
| ) |  |

virtual

This method is required for all derived classes of EffectBase, and returns a modified openshot::Frame object.

The frame object is passed into this method, and a frame_number is passed in which tells the effect which settings to use from it's keyframes (starting at 1).

Returns
  The modified openshot::Frame object

Parameters

  frame | The frame object that needs the effect applied to it
  frame_number | The frame number (starting at 1) of the effect on the timeline.

Implements openshot::EffectBase.

Definition at line 62 of file ColorShift.cpp.

## Json()

string ColorShift::Json | ( |  | ) |

virtual

Get and Set JSON methods.

Generate JSON string of this object

Implements openshot::EffectBase.

Definition at line 194 of file ColorShift.cpp.

## JsonValue()

Json::Value ColorShift::JsonValue | ( |  | ) |

virtual

Generate Json::JsonValue for this object.

Implements openshot::EffectBase.

Definition at line 201 of file ColorShift.cpp.

## PropertiesJSON()

string ColorShift::PropertiesJSON | ( | int64_t | requested_frame | ) |

virtual

Get all properties for a specific frame (perfect for a UI to display the current state of all properties at any time)

Implements openshot::ClipBase.

Definition at line 268 of file ColorShift.cpp.

## SetJson()

void ColorShift::SetJson | ( | string | value | ) |

virtual

Load JSON string into this object.

Implements openshot::EffectBase.

Definition at line 220 of file ColorShift.cpp.

## SetJsonValue()

void ColorShift::SetJsonValue | ( | Json::Value | root | ) |

virtual

Load Json::JsonValue into this object.

Implements openshot::EffectBase.

Definition at line 243 of file ColorShift.cpp.

## Member Data Documentation

## alpha_x

Keyframe openshot::ColorShift::alpha_x

Shift the Alpha X coordinates (left or right)

Definition at line 65 of file ColorShift.h.

## alpha_y

Keyframe openshot::ColorShift::alpha_y

Shift the Alpha Y coordinates (up or down)

Definition at line 66 of file ColorShift.h.

## blue_x

Keyframe openshot::ColorShift::blue_x

Shift the Blue X coordinates (left or right)

Definition at line 63 of file ColorShift.h.

## blue_y

Keyframe openshot::ColorShift::blue_y

Shift the Blue Y coordinates (up or down)

Definition at line 64 of file ColorShift.h.

## green_x

Keyframe openshot::ColorShift::green_x

Shift the Green X coordinates (left or right)

Definition at line 61 of file ColorShift.h.

## green_y

Keyframe openshot::ColorShift::green_y

Shift the Green Y coordinates (up or down)

Definition at line 62 of file ColorShift.h.

## red_x

Keyframe openshot::ColorShift::red_x

Shift the Red X coordinates (left or right)

Definition at line 59 of file ColorShift.h.

## red_y

Keyframe openshot::ColorShift::red_y

Shift the Red Y coordinates (up or down)

Definition at line 60 of file ColorShift.h.

The documentation for this class was generated from the following files:

- ColorShift.h
- ColorShift.cpp